Index: /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp	(revision 579)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp	(revision 580)
@@ -2857,7 +2799,7 @@
 
 	Debug << "neighbormap size: " << (int)neighborMap.size() << endl;
-	Debug << "mergequeue: " << (int)mMergeQueue.size() << endl;
+	Debug << "merge queue: " << (int)candidates.size() << endl;
 	Debug << "leaves in queue: " << numLeaves << endl;
-	Debug << "overall cost: " << BspMergeCandidate::sOverallCost << endl;
+
 
 	//-- collect the leaves which haven't been found by ray casting
@@ -2868,5 +2810,5 @@
 		CollectLeaves(leaves, true);
 		Debug << "found " << (int)leaves.size() << " new leaves" << endl << endl;
-		CollectMergeCandidates(leaves);
+		CollectMergeCandidates(leaves, candidates);
 	}
 
@@ -2875,391 +2817,4 @@
 
 
-void VspBspTree::ConstructBspRays(vector<BspRay *> &bspRays,
-								  const VssRayContainer &rays)
-{
-	VssRayContainer::const_iterator it, it_end = rays.end();
-
-	for (it = rays.begin(); it != rays.end(); ++ it)
-	{
-		VssRay *vssRay = *it;
-		BspRay *ray = new BspRay(vssRay);
-
-		ViewCellContainer viewCells;
-
-		Ray hray(*vssRay);
-		float tmin = 0, tmax = 1.0;
-		// matt TODO: remove this!!
-		//hray.Init(ray.GetOrigin(), ray.GetDir(), Ray::LINE_SEGMENT);
-		if (!mBox.GetRaySegment(hray, tmin, tmax) || (tmin > tmax))
-			continue;
-
-		Vector3 origin = hray.Extrap(tmin);
-		Vector3 termination = hray.Extrap(tmax);
-	
-		// cast line segment to get intersections with bsp leaves
-		CastLineSegment(origin, termination, viewCells);
-
-		ViewCellContainer::const_iterator vit, vit_end = viewCells.end();
-		for (vit = viewCells.begin(); vit != vit_end; ++ vit)
-		{
-			BspViewCell *vc = dynamic_cast<BspViewCell *>(*vit);
-			vector<BspLeaf *>::const_iterator it, it_end = vc->mLeaves.end();
-			//NOTE: not sorted!
-			for (it = vc->mLeaves.begin(); it != it_end; ++ it)
-			{
-				ray->intersections.push_back(BspIntersection(0, *it));
-			}
-		}
-
-		bspRays.push_back(ray);
-	}
-}
-
-
-#if 1
-int VspBspTree::MergeViewCells(const VssRayContainer &rays, const ObjectContainer &objects)
-{
-	BspMergeCandidate::sViewCellsManager = mViewCellsManager;
-	BspMergeCandidate::sUseArea = mUseAreaForPvs;
-
-
-	//-- compute statistics values of initial view cells
-	mViewCellsManager->EvaluateRenderStatistics(BspMergeCandidate::sOverallCost, 
-												BspMergeCandidate::sExpectedCost,
-												BspMergeCandidate::sVariance);
-
-
-	//BspMergeCandidate::sExpectedCost = 
-	//	BspMergeCandidate::sOverallCost / BspMergeCandidate::sNumViewCells;
-
-
-	ViewCellsManager::PvsStatistics pvsStats;
-	mViewCellsManager->GetPvsStatistics(pvsStats);
-
-	static float expectedValue = pvsStats.avgPvs;
-	
-	// the current view cells are kept in this container
-	ViewCellContainer viewCells;
-	if (mExportMergedViewCells)
-	{
-		ViewCell::NewMail();
-		CollectViewCells(mRoot, true, viewCells, true);
-	}
-
-
-	ViewCell::NewMail();
-
-	MergeStatistics mergeStats;
-	mergeStats.Start();
-	
-	long startTime = GetTime();
-
-	cout << "collecting merge candidates ... " << endl;
-	
-	if (mUseRaysForMerge)
-	{
-		mergeStats.nodes = CollectMergeCandidates(rays);
-	}
-	else
-	{
-		vector<BspLeaf *> leaves;
-		CollectLeaves(leaves);
-		mergeStats.nodes = CollectMergeCandidates(leaves);
-	}
-	
-	cout << "fininshed collecting candidates" << endl;
-
-	mergeStats.collectTime = TimeDiff(startTime, GetTime());
-	mergeStats.candidates = (int)mMergeQueue.size();
-	startTime = GetTime();
-
-	// frequency stats are updated
-	const int statsOut = 100;
-
-	// number of view cells withouth the invalid ones
-	BspMergeCandidate::sNumViewCells = mBspStats.Leaves() - mBspStats.invalidLeaves;
-
-	// passes are needed for statistics, because we don't want to record
-	// every merge
-	const int maxMergesPerPass = 100;
-	int pass = 0;
-
-	// maximal ratio of old expected render cost to expected render
-	// when the the render queue has to be reset.
-	const float ercMaxRatio = 0.7f;
-	
-	cout << "actual merge starts now ... " << endl;
-
-	
-	
-	//-- use priority queue to merge leaf pairs
-
-
-	while (!mMergeQueue.empty() && 
-		   (BspMergeCandidate::sNumViewCells > mMergeMinViewCells) &&
-		   (mMergeQueue.top().GetMergeCost() < mMergeMaxCostRatio * BspMergeCandidate::sOverallCost))
-	{
-
-		int mergedPerPass = 0;
-		const float oldExpectedCost = BspMergeCandidate::sExpectedCost;
-		
-//#ifdef _DEBUG
-		Debug << "abs mergecost: " << mMergeQueue.top().GetMergeCost() << " rel mergecost: "
-			  << mMergeQueue.top().GetMergeCost() / BspMergeCandidate::sOverallCost 
-			  << " max ratio: " << mMergeMaxCostRatio << endl
-			  << " expected value: " << oldExpectedCost << endl;
-//#endif
-
-		while (!mMergeQueue.empty() && 
-			   (BspMergeCandidate::sNumViewCells > mMergeMinViewCells) &&
-			   (ercMaxRatio > oldExpectedCost / BspMergeCandidate::sExpectedCost) &&
-			   (mMergeQueue.top().GetMergeCost() < mMergeMaxCostRatio * BspMergeCandidate::sOverallCost) &&
-			   (maxMergesPerPass < mergedPerPass));
-		{
-				Debug << "erc max ratio" << ercMaxRatio << endl;
-
-				BspMergeCandidate mc = mMergeQueue.top();
-				mMergeQueue.pop();
-
-				// both view cells equal!
-				if (mc.GetLeaf1()->GetViewCell() == mc.GetLeaf2()->GetViewCell())
-					continue;
-
-				if (mc.Valid())
-				{
-					ViewCell::NewMail();
-					const float currentMergeCost = mc.GetMergeCost();
-
-					MergeViewCells(mc.GetLeaf1(), mc.GetLeaf2());
-					
-					-- BspMergeCandidate::sNumViewCells;
-					++ mergeStats.merged;
-					++ mergedPerPass;
-
-					// increase absolute merge cost
-					BspMergeCandidate::sOverallCost += mc.GetRenderCost();
-					BspMergeCandidate::sVariance = mc.GetVarianceIncr();
-
-					BspMergeCandidate::sExpectedCost = 
-						BspMergeCandidate::sOverallCost / (float)BspMergeCandidate::sNumViewCells;
-
-					// stats
-					if (mc.GetLeaf1()->IsSibling(mc.GetLeaf2()))
-						++ mergeStats.siblings;
-
-					if (0)
-					{
-						const int dist = 
-							TreeDistance(mc.GetLeaf1(), mc.GetLeaf2());
-						if (dist > mergeStats.maxTreeDist)
-							mergeStats.maxTreeDist = dist;
-						mergeStats.accTreeDist += dist;
-					}
-
-					if ((mergeStats.merged % statsOut) == 0)
-					{
-						cout << "merged " << mergeStats.merged << " view cells" << endl;
-
-						mStats 
-							<< "#Pass\n" << pass << endl
-							<< "#Merged\n" << mergeStats.merged << endl 
-							<< "#Viewcells\n" << BspMergeCandidate::sNumViewCells << endl 
-							<< "#OverallCost\n" << BspMergeCandidate::sOverallCost << endl
-							<< "#CurrentCost\n" << currentMergeCost << endl
-							<< "#RelativeCost\n" << currentMergeCost / BspMergeCandidate::sOverallCost << endl
-							<< "#CurrentPvs\n" << mc.GetLeaf1()->GetViewCell()->GetPvs().GetSize() << endl
-							<< "#MergedSiblings\n" << mergeStats.siblings << endl
-							<< "#AvgTreeDist\n" << mergeStats.AvgTreeDist() << endl
-							<< "#ExpectedCost\n" << BspMergeCandidate::sExpectedCost << endl
-							<< "#RatioExpectedCost\n" << oldExpectedCost / BspMergeCandidate::sExpectedCost << endl
-							<< "#variance\n" << BspMergeCandidate::sVariance << endl;
-
-						if (mExportMergedViewCells)
-							ExportMergedViewCells(viewCells, objects, BspMergeCandidate::sNumViewCells);
-					}
-				}
-				else
-				{ 
-
-					// merge candidate not valid, because one of the leaves was already
-					// merged with another one => validate and reinsert into queue
-					mc.SetValid();
-					mMergeQueue.push(mc);
-				}
-		}
-	
-
-		++ pass;
-	}
-
-	mergeStats.overallCost = BspMergeCandidate::sOverallCost;
-
-	mergeStats.mergeTime = TimeDiff(startTime, GetTime());
-	mergeStats.Stop();
-
-	Debug << mergeStats << endl << endl;
-	
-	// delete the view cells which were already merged
-	CLEAR_CONTAINER(mOldViewCells);
-	
-
-	//TODO: should return sample contributions?
-	return mergeStats.merged;
-}
-
-#else
-
-int VspBspTree::MergeViewCells(const VssRayContainer &rays, const ObjectContainer &objects)
-{
-	BspMergeCandidate::sViewCellsManager = mViewCellsManager;
-	BspMergeCandidate::sUseArea = mUseAreaForPvs;
-
-	ViewCellsManager::PvsStatistics pvsStats;
-	mViewCellsManager->GetPvsStatistics(pvsStats);
-
-	static float expectedValue = pvsStats.avgPvs;
-	// the current view cells are kept in this container
-	ViewCellContainer viewCells;
-	if (mExportMergedViewCells)
-	{
-		ViewCell::NewMail();
-		CollectViewCells(mRoot, true, viewCells, true);
-	}
-	ViewCell::NewMail();
-
-	MergeStatistics mergeStats;
-	mergeStats.Start();
-	
-	//BspMergeCandidate::sOverallCost = mBox.SurfaceArea() * mBspStats.maxPvs;
-	long startTime = GetTime();
-
-	cout << "collecting merge candidates ... " << endl;
-	
-	if (mUseRaysForMerge)
-	{
-		mergeStats.nodes = CollectMergeCandidates(rays);
-	}
-	else
-	{
-		vector<BspLeaf *> leaves;
-		CollectLeaves(leaves);
-		mergeStats.nodes = CollectMergeCandidates(leaves);
-	}
-	
-	cout << "fininshed collecting candidates" << endl;
-
-	mergeStats.collectTime = TimeDiff(startTime, GetTime());
-	mergeStats.candidates = (int)mMergeQueue.size();
-	startTime = GetTime();
-
-	
-	// number of view cells withouth the invalid ones
-	int nViewCells = mBspStats.Leaves() - mBspStats.invalidLeaves;
-	BspMergeCandidate::sExpectedCost = BspMergeCandidate::sOverallCost / (float)nViewCells;
-
-	// passes are needed for statistics, because we don't want to record
-	// every merge
-	const int mergesPerPass = 100;
-	
-	int nextPass = 0;
-    int pass = 0;
-	
-	
-	Debug << "stats: " << nextStats << " " << statsIncr << endl;
-	cout << "actual merge starts now ... " << endl;
-
-	//-- use priority queue to merge leaf pairs
-	while (!mMergeQueue.empty() && (nViewCells > mMergeMinViewCells) &&
-		   (mMergeQueue.top().GetMergeCost() <
-		    mMergeMaxCostRatio * BspMergeCandidate::sOverallCost))
-	{
-#ifdef _DEBUG
-		Debug << "abs mergecost: " << mMergeQueue.top().GetMergeCost() << " rel mergecost: "
-			  << mMergeQueue.top().GetMergeCost() / BspMergeCandidate::sOverallCost 
-			  << " max ratio: " << mMergeMaxCostRatio << endl;
-#endif
-
-		BspMergeCandidate mc = mMergeQueue.top();
-		mMergeQueue.pop();
-
-
-		// both view cells equal!
-		if (mc.GetLeaf1()->GetViewCell() == mc.GetLeaf2()->GetViewCell())
-			continue;
-
-		if (mc.Valid())
-		{
-			ViewCell::NewMail();
-			const float mergeCost = mc.GetMergeCost();
-
-			MergeViewCells(mc.GetLeaf1(), mc.GetLeaf2());
-					
-			// increase absolute merge cost
-			BspMergeCandidate::sOverallCost += mc.GetMergeCost();
-			
-
-			-- nViewCells;
-			++ mergeStats.merged;
-
-			if ((mergeStats.merged % 500) == 0)
-				cout << "merged " << mergeStats.merged << " view cells" << endl;
-
-			// stats and visualizations
-			if (mExportMergeStats)
-			{
-				if (mc.GetLeaf1()->IsSibling(mc.GetLeaf2()))
-					++ mergeStats.siblings;
-
-				if (0)
-				const int dist = 
-					TreeDistance(mc.GetLeaf1(), mc.GetLeaf2());
-				if (dist > mergeStats.maxTreeDist)
-					mergeStats.maxTreeDist = dist;
-				mergeStats.accTreeDist += dist;
-
-				if ((mergeStats.merged == nextPass) || (nViewCells == mMergeMinViewCells))
-				{
-					nextPass += mergesPerPass;
-
-					mStats 
-						<< "#Pass\n" << pass ++ << endl
-						<< "#Merged\n" << mergeStats.merged << endl 
-						<< "#Viewcells\n" << nViewCells << endl 
-						<< "#OverallCost\n" << BspMergeCandidate::sOverallCost << endl
-						<< "#CurrentCost\n" << mergeCost << endl
-						<< "#RelativeCost\n" << mergeCost / BspMergeCandidate::sOverallCost << endl
-						<< "#CurrentPvs\n" << mc.GetLeaf1()->GetViewCell()->GetPvs().GetSize() << endl
-						<< "#MergedSiblings\n" << mergeStats.siblings << endl
-						<< "#AvgTreeDist\n" << mergeStats.AvgTreeDist() << endl;
-
-						if (mExportMergedViewCells)
-							ExportMergedViewCells(viewCells, objects, nViewCells);
-				}
-			}
-		}
-		// merge candidate not valid, because one of the leaves was already
-		// merged with another one => validate and reinsert into queue
-		else
-		{ 
-			mc.SetValid();
-			mMergeQueue.push(mc);
-		}
-	}
-
-	mergeStats.overallCost = BspMergeCandidate::sOverallCost;
-
-	mergeStats.mergeTime = TimeDiff(startTime, GetTime());
-	mergeStats.Stop();
-
-	Debug << mergeStats << endl << endl;
-	
-	// delete the view cells which were already merged
-	CLEAR_CONTAINER(mOldViewCells);
-	
-
-	//TODO: should return sample contributions?
-	return mergeStats.merged;
-}
-#endif
 
 
@@ -3297,326 +2852,4 @@
 
 
-void VspBspTree::ExportMergedViewCells(ViewCellContainer &viewCells, 
-									   const ObjectContainer &objects,
-									   const int nViewCells)
-{
-	ViewCellContainer::const_iterator vit, vit_end = viewCells.end();
-					
-	// find all already merged view cells and remove them from view cells
-	int i = 0;
-
-	while (1)
-	{
-		//while (!viewCells.empty() && (viewCells.back()->mMailbox == -1))
-		while (!viewCells.empty() && (viewCells.back()->GetId() == -2))
-		{
-			//DEL_PTR(viewCells.back());
-			viewCells.pop_back();
-		}
-		// all merged view cells have been found
-		if (i >= viewCells.size()) 
-			break;
-
-		// already merged view cell, put it to end of vector
-		//if (viewCells[i]->mMailbox == -1)
-		if (viewCells[i]->GetId() == -2)
-			swap(viewCells[i], viewCells.back());
-		
-		++ i;
-	}
-
-	int newVcSize = 0;
-	// add new view cells to container only if they don't have been 
-	// merged in the mean time
-	while (!mNewViewCells.empty())
-	{
-		if (mNewViewCells.back()->GetId() != -2)
-		{
-			viewCells.push_back(mNewViewCells.back());
-			++ newVcSize;
-		}
-
-		mNewViewCells.pop_back();
-	}
-
-	char s[64];
-	sprintf(s, "merged_viewcells%07d.x3d", nViewCells);
-	Exporter *exporter = Exporter::GetExporter(s);
-
-	if (exporter)
-	{
-		cout << "exporting " << nViewCells << " merged view cells ... ";
-		exporter->ExportGeometry(objects);
-		//Debug << "vc size " << (int)viewCells.size() << " merge queue size: " << (int)mMergeQueue.size() << endl;
-		ViewCellContainer::const_iterator it, it_end = viewCells.end();
-
-		int i = 0;
-		for (it = viewCells.begin(); it != it_end; ++ it)
-		{
-			Material m;
-			// assign special material to new view cells
-			// new view cells are on the back of container
-			if (i ++ >= (viewCells.size() - newVcSize))
-			{
-				//m = RandomMaterial();
-				m.mDiffuseColor.r = RandomValue(0.5f, 1.0f);
-				m.mDiffuseColor.g = RandomValue(0.5f, 1.0f);
-				m.mDiffuseColor.b = RandomValue(0.5f, 1.0f);
-			}
-			else
-			{
-				float col = RandomValue(0.1f, 0.4f);
-				m.mDiffuseColor.r = col;
-				m.mDiffuseColor.g = col;
-				m.mDiffuseColor.b = col;
-			}
-
-			exporter->SetForcedMaterial(m);
-			mViewCellsManager->ExportVcGeometry(exporter, *it);
-		}
-		delete exporter;
-		cout << "finished" << endl;
-	}
-
-	// delete the view cells which were merged
-	CLEAR_CONTAINER(mOldViewCells);
-	// remove the new view cells
-	mNewViewCells.clear();
-}
-
-
-int VspBspTree::RefineViewCells(const VssRayContainer &rays, const ObjectContainer &objects)
-{
-	Debug << "refining " << (int)mMergeQueue.size() << " candidates " << endl;
-	
-	BspLeaf::NewMail();
-
-	// Use priority queue of remaining leaf pairs 
-	// The candidates either share the same view cells or
-	// are border leaves which share a boundary.
-	// We test if they can be shuffled, i.e.,
-	// either one leaf is made part of one view cell or the other
-	// leaf is made part of the other view cell. It is tested if the
-	// remaining view cells are "better" than the old ones.
-	//
-	// repeat the merging test numPasses times. For example, it could be
-	// that a shuffle only makes sense if another pair was shuffled before.
-	// Therefore we keep two queues and shift the merge candidates between
-	// those two queues until numPasses is reached
-	
-	queue<BspMergeCandidate> queue1;
-	queue<BspMergeCandidate> queue2;
-
-	queue<BspMergeCandidate> *shuffleQueue = &queue1;
-	queue<BspMergeCandidate> *backQueue = &queue2;
-
-	while (!mMergeQueue.empty())
-	{
-		BspMergeCandidate mc = mMergeQueue.top();
-		shuffleQueue->push(mc);
-		mMergeQueue.pop();
-	}
-
-	const int numPasses = 5;
-	int pass = 0;
-	int passShuffled = 0;
-	int shuffled = 0;
-
-	BspLeaf::NewMail();
-
-	do
-	{
-		passShuffled = 0;
-		while (!shuffleQueue->empty())
-		{
-			BspMergeCandidate mc = shuffleQueue->front();
-			shuffleQueue->pop();
-
-			// both view cells equal or already shuffled
-			if ((mc.GetLeaf1()->GetViewCell() == mc.GetLeaf2()->GetViewCell()))// ||
-			//	(mc.GetLeaf1()->Mailed()) || (mc.GetLeaf2()->Mailed()))
-				continue;
-		
-			// candidate for shuffling
-			const bool wasShuffled = 
-				ShuffleLeaves(mc.GetLeaf1(), mc.GetLeaf2());
-		
-			if (wasShuffled)
-				++ passShuffled;
-			else
-				backQueue->push(mc);
-		}
-
-		// now the back queue is the current shuffle queue
-		swap(shuffleQueue, backQueue);
-		shuffled += passShuffled;
-		Debug << "shuffled in pass: " << passShuffled << endl;
-	}
-	while (((++ pass) < numPasses) && passShuffled);
-
-	while (!shuffleQueue->empty())
-	{
-		shuffleQueue->pop();
-	}
-
-	return shuffled;
-}
-
-
-inline int AddedPvsSize(ObjectPvs pvs1, const ObjectPvs &pvs2)
-{
-	return pvs1.AddPvs(pvs2);
-}
-
-
-// recomputes pvs size minus pvs of leaf l
-#if 0
-inline int SubtractedPvsSize(BspViewCell *vc, BspLeaf *l, const ObjectPvs &pvs2)
-{
-	ObjectPvs pvs;
-	vector<BspLeaf *>::const_iterator it, it_end = vc->mLeaves.end();
-	for (it = vc->mLeaves.begin(); it != vc->mLeaves.end(); ++ it)
-		if (*it != l)
-			pvs.AddPvs(*(*it)->mPvs);
-	return pvs.GetSize();
-}
-#endif
-
-// computes pvs1 minus pvs2
-inline int SubtractedPvsSize(ObjectPvs pvs1, const ObjectPvs &pvs2)
-{
-	return pvs1.SubtractPvs(pvs2);
-}
-
-
-float VspBspTree::GetShuffledVcCost(BspLeaf *leaf, BspViewCell *vc1, BspViewCell *vc2) const
-{
-	//const int pvs1 = SubtractedPvsSize(vc1, leaf, *leaf->mPvs);
-	const int pvs1 = SubtractedPvsSize(vc1->GetPvs(), *leaf->mPvs);
-	const int pvs2 = AddedPvsSize(vc2->GetPvs(), *leaf->mPvs);
-
-	// don't shuffle leaves with pvs > max
-	if (pvs1 + pvs2 > mViewCellsManager->GetMaxPvsSize())
-		return 1e15f;
-
-#if 1
-	float p1, p2;
-
-    if (mUseAreaForPvs)
-	{
-		p1 = vc1->GetArea() - leaf->mProbability;
-		p2 = vc2->GetArea() + leaf->mProbability;
-	}
-	else
-	{
-		p1 = vc1->GetVolume() - leaf->mProbability;
-		p2 = vc2->GetVolume() + leaf->mProbability;
-	}
-
-	const float cost1 = pvs1 * p1;
-	const float cost2 = pvs2 * p2;
-#else
-	const float cost1 = pvs1;
-	const float cost2 = pvs2;
-#endif
-
-	return cost1 + cost2;
-}
-
-
-void VspBspTree::ShuffleLeaf(BspLeaf *leaf, 
-							 BspViewCell *vc1, 
-							 BspViewCell *vc2) const
-{
-	// compute new pvs and area
-	vc1->GetPvs().SubtractPvs(*leaf->mPvs);
-	vc2->GetPvs().AddPvs(*leaf->mPvs);
-	
-	if (mUseAreaForPvs)
-	{
-		vc1->SetArea(vc1->GetArea() - leaf->mProbability);
-		vc2->SetArea(vc2->GetArea() + leaf->mProbability);
-	}
-	else
-	{
-		vc1->SetVolume(vc1->GetVolume() - leaf->mProbability);
-		vc2->SetVolume(vc2->GetVolume() + leaf->mProbability);
-	}
-
-	/// add to second view cell
-	vc2->mLeaves.push_back(leaf);
-
-	// erase leaf from old view cell
-	vector<BspLeaf *>::iterator it = vc1->mLeaves.begin();
-
-	for (; *it != leaf; ++ it);
-	vc1->mLeaves.erase(it);
-
-	/*vc1->GetPvs().mEntries.clear();
-	for (; it != vc1->mLeaves.end(); ++ it)
-	{
-		if (*it == leaf)
-			vc1->mLeaves.erase(it);
-		else
-			vc1->GetPvs().AddPvs(*(*it)->mPvs);
-	}*/
-
-	leaf->SetViewCell(vc2); // finally change view cell
-}
-
-
-bool VspBspTree::ShuffleLeaves(BspLeaf *leaf1, BspLeaf *leaf2) const
-{
-	BspViewCell *vc1 = leaf1->GetViewCell();
-	BspViewCell *vc2 = leaf2->GetViewCell();
-
-	float cost1, cost2;
-
-#if 1
-	if (mUseAreaForPvs)
-	{
-		cost1 = vc1->GetPvs().GetSize() * vc1->GetArea();
-		cost2 = vc2->GetPvs().GetSize() * vc2->GetArea();
-	}
-	else
-	{
-		cost1 = vc1->GetPvs().GetSize() * vc1->GetVolume();
-		cost2 = vc2->GetPvs().GetSize() * vc2->GetVolume();
-	}
-#else
-	cost1 = vc1->GetPvs().GetSize(); 
-	cost2 = vc2->GetPvs().GetSize(); 
-#endif
-
-	const float oldCost = cost1 + cost2;
-	
-	float shuffledCost1 = Limits::Infinity;
-	float shuffledCost2 = Limits::Infinity;
-
-	// the view cell should not be empty after the shuffle
-	if (vc1->mLeaves.size() > 1)
-		shuffledCost1 = GetShuffledVcCost(leaf1, vc1, vc2);
-	if (vc2->mLeaves.size() > 1)
-		shuffledCost2 = GetShuffledVcCost(leaf2, vc2, vc1);
-
-	// shuffling unsuccessful
-	if ((oldCost <= shuffledCost1) && (oldCost <= shuffledCost2))
-		return false;
-	
-	if (shuffledCost1 < shuffledCost2)
-	{
-		ShuffleLeaf(leaf1, vc1, vc2);
-		leaf1->Mail();
-	}
-	else
-	{
-		ShuffleLeaf(leaf2, vc2, vc1);
-		leaf2->Mail();
-	}
-
-	return true;
-}
-
-
 bool VspBspTree::ViewPointValid(const Vector3 &viewPoint) const
 {
@@ -3713,224 +2946,2 @@
 	}
 }
-
-
-/**************************************************************************/
-/*                  BspMergeCandidate implementation                      */
-/**************************************************************************/
-
-
-BspMergeCandidate::BspMergeCandidate(BspLeaf *l1, BspLeaf *l2):
-mRenderCost(0),
-mVarianceIncr(0),
-mLeaf1(l1),
-mLeaf2(l2),
-mLeaf1Id(l1->GetViewCell()->mMailbox),
-mLeaf2Id(l2->GetViewCell()->mMailbox)
-{
-	//EvalMergeCost();
-}
-
-
-float BspMergeCandidate::GetRenderCost(ViewCell *vc) const
-{
-	if (sUseArea)
-		return vc->GetPvs().GetSize() * vc->GetArea();
-
-	return vc->GetPvs().GetSize() * vc->GetVolume();
-}
-
-
-float BspMergeCandidate::GetLeaf1Cost() const
-{
-	BspViewCell *vc = mLeaf1->GetViewCell();
-
-	return GetRenderCost(vc);
-}
-
-
-float BspMergeCandidate::GetLeaf2Cost() const
-{
-	BspViewCell *vc = mLeaf2->GetViewCell();
-
-	return GetRenderCost(vc);
-}
-
-
-int ComputeMergedPvsSize(const ObjectPvs &pvs1, const ObjectPvs &pvs2)
-{
-	int pvs = pvs1.GetSize();
-
-	// compute new pvs size
-	ObjectPvsMap::const_iterator it, it_end =  pvs1.mEntries.end();
-
-	Intersectable::NewMail();
-
-	for (it = pvs1.mEntries.begin(); it != it_end; ++ it)
-	{
-		(*it).first->Mail();
-	}
-
-	it_end = pvs2.mEntries.end();
-
-	for (it = pvs2.mEntries.begin(); it != it_end; ++ it)
-	{
-		Intersectable *obj = (*it).first;
-		if (!obj->Mailed())
-			++ pvs;
-	}
-
-	return pvs;
-}
-
-
-
-void BspMergeCandidate::EvalMergeCost()
-{
-	//-- compute pvs difference
-	BspViewCell *vc1 = mLeaf1->GetViewCell();
-	BspViewCell *vc2 = mLeaf2->GetViewCell();
-
-	const int newPvs = ComputeMergedPvsSize(vc1->GetPvs(), vc2->GetPvs());
-	const float newPenalty = 
-		EvalPvsPenalty(newPvs, 
-					   sViewCellsManager->GetMinPvsSize(),
-					   sViewCellsManager->GetMaxPvsSize());
-
-	//-- compute ratio of old cost
-	//   (i.e., added size of left and right view cell times pvs size)
-	//   to new rendering cost (i.e, size of merged view cell times pvs size)
-	const float oldCost = GetLeaf1Cost() + GetLeaf2Cost();
-
-    const float newCost = sUseArea ? 
-		(float)newPvs * (vc1->GetArea() + vc2->GetArea()) :
-		(float)newPvs * (vc1->GetVolume() + vc2->GetVolume());
-
-
-	if (newPvs > sViewCellsManager->GetMaxPvsSize()) // strong penalty if pvs size too large
-	{
-		mRenderCost = 1e15;
-	}
-	else
-	{
-		mRenderCost = newCost - oldCost;
-	}
-
-	// merge cost also takes variance into account
-
-	const float oldVar1 = GetLeaf1Variance();
-	const float oldVar2 = GetLeaf2Variance();
-
-	const float newVar = (sExpectedCost - mRenderCost) * (sExpectedCost - mRenderCost);
-
-	mVarianceIncr = (newVar - oldVar1 - oldVar2) / sNumViewCells;
-	//mMergeCost = mRenderCost + fabs(newPenalty - BspMergeCandidate::sExpectedCost) ;
-}
-
-
-void BspMergeCandidate::SetLeaf1(BspLeaf *l)
-{
-	mLeaf1 = l;
-}
-
-
-void BspMergeCandidate::SetLeaf2(BspLeaf *l)
-{
-	mLeaf2 = l;
-}
-
-
-BspLeaf *BspMergeCandidate::GetLeaf1() const
-{
-	return mLeaf1;
-}
-
-
-BspLeaf *BspMergeCandidate::GetLeaf2() const
-{
-	return mLeaf2;
-}
-
-
-bool BspMergeCandidate::Valid() const
-{
-	return
-		(mLeaf1->GetViewCell()->mMailbox == mLeaf1Id) &&
-		(mLeaf2->GetViewCell()->mMailbox == mLeaf2Id);
-}
-
-
-float BspMergeCandidate::GetMergeCost() const
-{
-	return mRenderCost * sRenderCostWeight + mVarianceIncr * (1.0f - sRenderCostWeight);
-}
-
-
-float BspMergeCandidate::GetRenderCost() const
-{
-	return mRenderCost;
-}
-
-
-float BspMergeCandidate::GetVarianceIncr() const
-{
-	return mVarianceIncr;
-}
-
-float BspMergeCandidate::GetLeaf1Variance() const
-{
-	const float leafCost = GetLeaf1Cost();
-	
-	return (sExpectedCost - leafCost) * (sExpectedCost - leafCost);
-}
-
-
-float BspMergeCandidate::GetLeaf2Variance() const
-{
-	const float leafCost = GetLeaf2Cost();
-	
-	return (sExpectedCost - leafCost) * (sExpectedCost - leafCost);
-}
-
-
-void BspMergeCandidate::SetValid()
-{
-	mLeaf1Id = mLeaf1->GetViewCell()->mMailbox;
-	mLeaf2Id = mLeaf2->GetViewCell()->mMailbox;
-
-	EvalMergeCost();
-}
-
-
-/************************************************************************/
-/*                    MergeStatistics implementation                    */
-/************************************************************************/
-
-
-void MergeStatistics::Print(ostream &app) const
-{
-	app << "===== Merge statistics ===============\n";
-
-	app << setprecision(4);
-
-	app << "#N_CTIME ( Overall time [s] )\n" << Time() << " \n";
-
-	app << "#N_CCTIME ( Collect candidates time [s] )\n" << collectTime * 1e-3f << " \n";
-
-	app << "#N_MTIME ( Merge time [s] )\n" << mergeTime * 1e-3f << " \n";
-
-	app << "#N_NODES ( Number of nodes before merge )\n" << nodes << "\n";
-
-	app << "#N_CANDIDATES ( Number of merge candidates )\n" << candidates << "\n";
-
-	app << "#N_MERGEDSIBLINGS ( Number of merged siblings )\n" << siblings << "\n";
-
-	app << "#OVERALLCOST ( overall merge cost )\n" << overallCost << "\n";
-
-	app << "#N_MERGEDNODES ( Number of merged nodes )\n" << merged << "\n";
-
-	app << "#MAX_TREEDIST ( Maximal distance in tree of merged leaves )\n" << maxTreeDist << "\n";
-
-	app << "#AVG_TREEDIST ( Average distance in tree of merged leaves )\n" << AvgTreeDist() << "\n";
-
-	app << "===== END OF BspTree statistics ==========\n";
-}
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp	(revision 579)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp	(revision 580)
@@ -1283,4 +1283,43 @@
 		"false");
 	
+	
+	RegisterOption("ViewCells.PostProcess.maxCostRatio",
+			optFloat,
+			"-view_cells_post_process_max_cost_ratio=",
+			"0.9");
+
+	
+	RegisterOption("ViewCells.PostProcess.renderCostWeight",
+			optFloat,
+			"-view_cells_post_process_render_cost_weight",
+			"0.5");
+
+	
+	RegisterOption("ViewCells.PostProcess.avgCostMaxDeviation",
+			optFloat,
+			"-vsp_bsp_avgcost_max_deviations",
+			"0.5");
+
+	RegisterOption("ViewCells.PostProcess.maxMergesPerPass", 
+		optInt, 
+		"vsp_bsp_term_max_merges_per_pass=", 
+		"500");
+
+	RegisterOption("ViewCells.PostProcess.minViewCells", 
+		optInt, 
+		"vsp_bsp_term_post_process_min_view_cells=", 
+		"1000");
+
+	RegisterOption("ViewCells.PostProcess.useRaysForMerge", 
+		optBool,
+		"view_cells_post_process_use_rays_for_merge=", 
+		"false");
+
+	RegisterOption("ViewCells.Visualization.exportMergedViewCells",
+		optBool, 
+		"view_cells_viz_export_merged_viewcells=", 
+		"false");
+
+
 	/************************************************************************************/
 	/*                         Render simulation related options                        */
@@ -1834,18 +1873,10 @@
 	RegisterOption("VspBspTree.Factor.pvs", optFloat, "-vsp_bsp_factor_pvs=", "1.0");
 
-	RegisterOption("VspBspTree.PostProcess.maxCostRatio",
+
+	RegisterOption("VspBspTree.Construction.renderCostWeight",
 			optFloat,
-			"-vsp_bsp_post_process_max_cost_ratio=",
-			"0.9");
-
-	RegisterOption("VspBspTree.PostProcess.minViewCells", 
-		optInt, 
-		"vsp_bsp_term_post_process_min_view_cells=", 
-		"1000");
-
-	RegisterOption("VspBspTree.PostProcess.useRaysForMerge", 
-		optBool, 
-		"vsp_bsp_term_post_process_use_rays_for_merge=", 
-		"false");
+			"-vsp_bsp_post_process_render_cost_weight",
+			"0.5");
+
 
 	RegisterOption("VspBspTree.Construction.randomize", 
@@ -1865,13 +1896,6 @@
 		"8.0");
 
-	RegisterOption("VspBspTree.Visualization.exportMergedViewCells",
-		optBool, 
-		"vsp_bsp_viz_export_merged_viewcells=", 
-		"false");
-
-	RegisterOption("VspBspTree.PostProcess.exportMergeStats",
-		optBool, 
-		"vsp_bsp_viz_export_merge_stats=", 
-		"false");
+	
+	
 
 	//////////////////////////////////////////////////////////////////////////////////
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/KdTree.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/KdTree.cpp	(revision 556)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/KdTree.cpp	(revision 580)
@@ -888,5 +888,5 @@
 	  leaf->mViewCell = viewCell;
 	  // push back pointer to this leaf
-	  viewCell->mLeaves.push_back(leaf);
+	  viewCell->mLeaf = leaf;
       vc.push_back(viewCell);
     } else {
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 574)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 580)
@@ -208,7 +208,7 @@
 
 
-/******************************************************************/
-/*                    class BspTree implementation                */
-/******************************************************************/
+/*********************************************************************/
+/*                       class BspTree implementation                */
+/*********************************************************************/
 
 BspTree::BspTree():  
@@ -840,5 +840,5 @@
 		
 		leaf->SetViewCell(viewCell);
-		viewCell->mLeaves.push_back(leaf);
+		viewCell->mLeaf = leaf;
 
 		//-- add pvs
@@ -2208,10 +2208,11 @@
 void BspTree::ConstructGeometry(BspViewCell *vc, BspNodeGeometry &geom) const
 {
-	vector<BspLeaf *> leaves = vc->mLeaves;
+	// TODO
+/*	vector<BspLeaf *> leaves = vc->mLeaves;
 
 	vector<BspLeaf *>::const_iterator it, it_end = leaves.end();
 
 	for (it = leaves.begin(); it != it_end; ++ it)
-		ConstructGeometry(*it, geom);
+		ConstructGeometry(*it, geom);*/
 }
 
